
// This code conforms with the UFC specification version 2018.2.0.dev0
// and was automatically generated by FFCx version 0.9.0.dev0.
//
// This code was generated with the following options:
//
//  {'epsilon': 1e-14,
//   'output_directory': '.',
//   'profile': False,
//   'scalar_type': 'float64',
//   'sum_factorization': False,
//   'table_atol': 1e-09,
//   'table_rtol': 1e-06,
//   'ufl_file': ['/home/shared/sandbox/7b0ed8e55b8446fac0eff4b821dad67a/poisson.py'],
//   'verbosity': 30,
//   'visualise': False}

#include <math.h>
#include <stdalign.h>
#include <stdlib.h>
#include <string.h>
#include <ufcx.h>



// Code for integral integral_9e589da66bac6e7e5c5bc39b3de7d7e115f993ce

void tabulate_tensor_integral_9e589da66bac6e7e5c5bc39b3de7d7e115f993ce(double* restrict A,
                                    const double* restrict w,
                                    const double* restrict c,
                                    const double* restrict coordinate_dofs,
                                    const int* restrict entity_local_index,
                                    const uint8_t* restrict quadrature_permutation)
{
// Quadrature rules
static const double weights_083[1] = {0.5};
// Precomputed values of basis functions and precomputations
// FE* dimensions: [permutation][entities][points][dofs]
static const double FE0_C0_D01_Q083[1][1][1][3] = {{{{-1.0, 0.0, 1.0}}}};
static const double FE1_C0_D10_Q083[1][1][1][3] = {{{{-1.0, 1.0, 0.0}}}};
// ------------------------ 
// Section: Jacobian
// Inputs: FE0_C0_D01_Q083, FE1_C0_D10_Q083, coordinate_dofs
// Outputs: J_c1, J_c3, J_c0, J_c2
double J_c0 = 0.0;
double J_c3 = 0.0;
double J_c1 = 0.0;
double J_c2 = 0.0;
{
  for (int ic = 0; ic < 3; ++ic)
  {
    J_c0 += coordinate_dofs[(ic) * 3] * FE1_C0_D10_Q083[0][0][0][ic];
    J_c3 += coordinate_dofs[(ic) * 3 + 1] * FE0_C0_D01_Q083[0][0][0][ic];
    J_c1 += coordinate_dofs[(ic) * 3] * FE0_C0_D01_Q083[0][0][0][ic];
    J_c2 += coordinate_dofs[(ic) * 3 + 1] * FE1_C0_D10_Q083[0][0][0][ic];
  }
}
// ------------------------ 
double sp_083_0 = J_c0 * J_c3;
double sp_083_1 = J_c1 * J_c2;
double sp_083_2 = -sp_083_1;
double sp_083_3 = sp_083_0 + sp_083_2;
double sp_083_4 = J_c0 / sp_083_3;
double sp_083_5 = -J_c1;
double sp_083_6 = sp_083_5 / sp_083_3;
double sp_083_7 = sp_083_4 * sp_083_4;
double sp_083_8 = sp_083_4 * sp_083_6;
double sp_083_9 = sp_083_6 * sp_083_6;
double sp_083_10 = J_c3 / sp_083_3;
double sp_083_11 = -J_c2;
double sp_083_12 = sp_083_11 / sp_083_3;
double sp_083_13 = sp_083_12 * sp_083_12;
double sp_083_14 = sp_083_10 * sp_083_12;
double sp_083_15 = sp_083_10 * sp_083_10;
double sp_083_16 = sp_083_7 + sp_083_13;
double sp_083_17 = sp_083_8 + sp_083_14;
double sp_083_18 = sp_083_15 + sp_083_9;
double sp_083_19 = fabs(sp_083_3);
double sp_083_20 = sp_083_16 * sp_083_19;
double sp_083_21 = sp_083_17 * sp_083_19;
double sp_083_22 = sp_083_18 * sp_083_19;
for (int iq = 0; iq < 1; ++iq)
{
  // ------------------------ 
  // Section: Intermediates
  // Inputs: 
  // Outputs: fw0, fw1, fw2
  double fw0 = 0;
  double fw1 = 0;
  double fw2 = 0;
  {
    fw0 = sp_083_22 * weights_083[iq];
    fw1 = sp_083_21 * weights_083[iq];
    fw2 = sp_083_20 * weights_083[iq];
  }
  // ------------------------ 
  // ------------------------ 
  // Section: Tensor Computation
  // Inputs: fw1, FE0_C0_D01_Q083, fw0, FE1_C0_D10_Q083, fw2
  // Outputs: A
  {
    double temp_0[3] = {0};
    for (int j = 0; j < 3; ++j)
    {
      temp_0[j] = fw0 * FE1_C0_D10_Q083[0][0][0][j];
    }
    double temp_1[3] = {0};
    for (int j = 0; j < 3; ++j)
    {
      temp_1[j] = fw1 * FE0_C0_D01_Q083[0][0][0][j];
    }
    double temp_2[3] = {0};
    for (int j = 0; j < 3; ++j)
    {
      temp_2[j] = fw1 * FE1_C0_D10_Q083[0][0][0][j];
    }
    double temp_3[3] = {0};
    for (int j = 0; j < 3; ++j)
    {
      temp_3[j] = fw2 * FE0_C0_D01_Q083[0][0][0][j];
    }
    for (int j = 0; j < 3; ++j)
    {
      for (int i = 0; i < 3; ++i)
      {
        A[3 * (i) + (j)] += FE1_C0_D10_Q083[0][0][0][i] * temp_0[j];
        A[3 * (i) + (j)] += FE1_C0_D10_Q083[0][0][0][i] * temp_1[j];
        A[3 * (i) + (j)] += FE0_C0_D01_Q083[0][0][0][i] * temp_2[j];
        A[3 * (i) + (j)] += FE0_C0_D01_Q083[0][0][0][i] * temp_3[j];
      }
    }
  }
  // ------------------------ 
}

}



ufcx_integral integral_9e589da66bac6e7e5c5bc39b3de7d7e115f993ce =
{
  .enabled_coefficients = NULL,
  .tabulate_tensor_float32 = NULL,
  .tabulate_tensor_float64 = tabulate_tensor_integral_9e589da66bac6e7e5c5bc39b3de7d7e115f993ce,
  .tabulate_tensor_complex64 = NULL,
  .tabulate_tensor_complex128 = NULL,
  .needs_facet_permutations = false,
  .coordinate_element_hash = UINT64_C(0),
};

// End of code for integral integral_9e589da66bac6e7e5c5bc39b3de7d7e115f993ce

// Code for integral integral_b48d1eb48e2e0769ab58b939256a7911f4da7c3d

void tabulate_tensor_integral_b48d1eb48e2e0769ab58b939256a7911f4da7c3d(double* restrict A,
                                    const double* restrict w,
                                    const double* restrict c,
                                    const double* restrict coordinate_dofs,
                                    const int* restrict entity_local_index,
                                    const uint8_t* restrict quadrature_permutation)
{
// Quadrature rules
static const double weights_083[1] = {0.5};
// Precomputed values of basis functions and precomputations
// FE* dimensions: [permutation][entities][points][dofs]
static const double FE0_C0_Q083[1][1][1][3] = {{{{0.3333333333333334, 0.3333333333333333, 0.3333333333333333}}}};
static const double FE1_C0_D10_Q083[1][1][1][3] = {{{{-1.0, 1.0, 0.0}}}};
static const double FE1_C1_D01_Q083[1][1][1][3] = {{{{-1.0, 0.0, 1.0}}}};
// ------------------------ 
// Section: Jacobian
// Inputs: FE1_C1_D01_Q083, FE1_C0_D10_Q083, coordinate_dofs
// Outputs: J_c1, J_c3, J_c0, J_c2
double J_c0 = 0.0;
double J_c3 = 0.0;
double J_c1 = 0.0;
double J_c2 = 0.0;
{
  for (int ic = 0; ic < 3; ++ic)
  {
    J_c0 += coordinate_dofs[(ic) * 3] * FE1_C0_D10_Q083[0][0][0][ic];
    J_c3 += coordinate_dofs[(ic) * 3 + 1] * FE1_C1_D01_Q083[0][0][0][ic];
    J_c1 += coordinate_dofs[(ic) * 3] * FE1_C1_D01_Q083[0][0][0][ic];
    J_c2 += coordinate_dofs[(ic) * 3 + 1] * FE1_C0_D10_Q083[0][0][0][ic];
  }
}
// ------------------------ 
double sp_083_0 = J_c0 * J_c3;
double sp_083_1 = J_c1 * J_c2;
double sp_083_2 = -sp_083_1;
double sp_083_3 = sp_083_0 + sp_083_2;
double sp_083_4 = fabs(sp_083_3);
for (int iq = 0; iq < 1; ++iq)
{
  // ------------------------ 
  // Section: Intermediates
  // Inputs: 
  // Outputs: fw0
  double fw0 = 0;
  {
    fw0 = sp_083_4 * weights_083[iq];
  }
  // ------------------------ 
  // ------------------------ 
  // Section: Tensor Computation
  // Inputs: fw0, FE0_C0_Q083
  // Outputs: A
  {
    double temp_0[1] = {0};
    for (int j = 0; j < 1; ++j)
    {
      temp_0[j] = fw0 * 1;
    }
    for (int j = 0; j < 1; ++j)
    {
      for (int i = 0; i < 3; ++i)
      {
        A[(i) + (j)] += FE0_C0_Q083[0][0][0][i] * temp_0[j];
      }
    }
  }
  // ------------------------ 
}

}



ufcx_integral integral_b48d1eb48e2e0769ab58b939256a7911f4da7c3d =
{
  .enabled_coefficients = NULL,
  .tabulate_tensor_float32 = NULL,
  .tabulate_tensor_float64 = tabulate_tensor_integral_b48d1eb48e2e0769ab58b939256a7911f4da7c3d,
  .tabulate_tensor_complex64 = NULL,
  .tabulate_tensor_complex128 = NULL,
  .needs_facet_permutations = false,
  .coordinate_element_hash = UINT64_C(0),
};

// End of code for integral integral_b48d1eb48e2e0769ab58b939256a7911f4da7c3d

// Code for integral integral_b1a56654466bd2be9d6044d1e031c51bc4198978

void tabulate_tensor_integral_b1a56654466bd2be9d6044d1e031c51bc4198978(double* restrict A,
                                    const double* restrict w,
                                    const double* restrict c,
                                    const double* restrict coordinate_dofs,
                                    const int* restrict entity_local_index,
                                    const uint8_t* restrict quadrature_permutation)
{
// Quadrature rules
static const double weights_083[1] = {0.5};
// Precomputed values of basis functions and precomputations
// FE* dimensions: [permutation][entities][points][dofs]
static const double FE0_C0_Q083[1][1][1][3] = {{{{0.3333333333333334, 0.3333333333333333, 0.3333333333333333}}}};
static const double FE1_C0_D10_Q083[1][1][1][3] = {{{{-1.0, 1.0, 0.0}}}};
static const double FE1_C1_D01_Q083[1][1][1][3] = {{{{-1.0, 0.0, 1.0}}}};
// ------------------------ 
// Section: Jacobian
// Inputs: FE1_C1_D01_Q083, FE1_C0_D10_Q083, coordinate_dofs
// Outputs: J_c1, J_c3, J_c0, J_c2
double J_c0 = 0.0;
double J_c3 = 0.0;
double J_c1 = 0.0;
double J_c2 = 0.0;
{
  for (int ic = 0; ic < 3; ++ic)
  {
    J_c0 += coordinate_dofs[(ic) * 3] * FE1_C0_D10_Q083[0][0][0][ic];
    J_c3 += coordinate_dofs[(ic) * 3 + 1] * FE1_C1_D01_Q083[0][0][0][ic];
    J_c1 += coordinate_dofs[(ic) * 3] * FE1_C1_D01_Q083[0][0][0][ic];
    J_c2 += coordinate_dofs[(ic) * 3 + 1] * FE1_C0_D10_Q083[0][0][0][ic];
  }
}
// ------------------------ 
double sp_083_0 = J_c0 * J_c3;
double sp_083_1 = J_c1 * J_c2;
double sp_083_2 = -sp_083_1;
double sp_083_3 = sp_083_0 + sp_083_2;
double sp_083_4 = fabs(sp_083_3);
for (int iq = 0; iq < 1; ++iq)
{
  // ------------------------ 
  // Section: Intermediates
  // Inputs: 
  // Outputs: fw0
  double fw0 = 0;
  {
    fw0 = sp_083_4 * weights_083[iq];
  }
  // ------------------------ 
  // ------------------------ 
  // Section: Tensor Computation
  // Inputs: fw0, FE0_C0_Q083
  // Outputs: A
  {
    double temp_0[3] = {0};
    for (int j = 0; j < 3; ++j)
    {
      temp_0[j] = fw0 * 1 * FE0_C0_Q083[0][0][0][j];
    }
    for (int j = 0; j < 3; ++j)
    {
      for (int i = 0; i < 1; ++i)
      {
        A[3 * (i) + (j)] += temp_0[j];
      }
    }
  }
  // ------------------------ 
}

}



ufcx_integral integral_b1a56654466bd2be9d6044d1e031c51bc4198978 =
{
  .enabled_coefficients = NULL,
  .tabulate_tensor_float32 = NULL,
  .tabulate_tensor_float64 = tabulate_tensor_integral_b1a56654466bd2be9d6044d1e031c51bc4198978,
  .tabulate_tensor_complex64 = NULL,
  .tabulate_tensor_complex128 = NULL,
  .needs_facet_permutations = false,
  .coordinate_element_hash = UINT64_C(0),
};

// End of code for integral integral_b1a56654466bd2be9d6044d1e031c51bc4198978

// Code for integral integral_18752a675a270b48bccf204a6576982bd8afabd2

void tabulate_tensor_integral_18752a675a270b48bccf204a6576982bd8afabd2(double* restrict A,
                                    const double* restrict w,
                                    const double* restrict c,
                                    const double* restrict coordinate_dofs,
                                    const int* restrict entity_local_index,
                                    const uint8_t* restrict quadrature_permutation)
{
// Quadrature rules
static const double weights_b6a[15] = {0.02659041664838023, 0.02045908519702843, 0.06386262428056692, 0.02659041664838023, 0.02045908519702843, 0.06386262428056692, 0.02659041664838023, 0.02045908519702843, 0.06386262428056692, 0.02787727027034555, 0.02787727027034555, 0.02787727027034555, 0.02787727027034555, 0.02787727027034555, 0.02787727027034555};
// Precomputed values of basis functions and precomputations
// FE* dimensions: [permutation][entities][points][dofs]
static const double FE1_C0_D10_Qb6a[1][1][1][3] = {{{{-1.0, 1.0, 0.0}}}};
static const double FE1_C0_Qb6a[1][1][15][3] = {{{{0.05360869262149797, 0.473195653689251, 0.473195653689251},
  {0.8844047198909871, 0.05779764005450639, 0.05779764005450651},
  {0.5166727872055051, 0.2416636063972474, 0.2416636063972474},
  {0.4731956536892511, 0.473195653689251, 0.05360869262149792},
  {0.05779764005450645, 0.05779764005450645, 0.884404719890987},
  {0.2416636063972474, 0.2416636063972474, 0.5166727872055051},
  {0.4731956536892511, 0.05360869262149785, 0.473195653689251},
  {0.05779764005450659, 0.884404719890987, 0.05779764005450647},
  {0.2416636063972475, 0.5166727872055051, 0.2416636063972474},
  {0.6936897820041288, 0.04697120613008553, 0.2593390118657857},
  {0.2593390118657857, 0.6936897820041288, 0.04697120613008553},
  {0.04697120613008555, 0.2593390118657857, 0.6936897820041288},
  {0.6936897820041288, 0.2593390118657857, 0.04697120613008555},
  {0.04697120613008565, 0.6936897820041288, 0.2593390118657857},
  {0.2593390118657857, 0.04697120613008551, 0.6936897820041288}}}};
static const double FE1_C1_D01_Qb6a[1][1][1][3] = {{{{-1.0, 0.0, 1.0}}}};
// ------------------------ 
// Section: Jacobian
// Inputs: FE1_C1_D01_Qb6a, FE1_C0_D10_Qb6a, coordinate_dofs
// Outputs: J_c1, J_c3, J_c0, J_c2
double J_c0 = 0.0;
double J_c3 = 0.0;
double J_c1 = 0.0;
double J_c2 = 0.0;
{
  for (int ic = 0; ic < 3; ++ic)
  {
    J_c0 += coordinate_dofs[(ic) * 3] * FE1_C0_D10_Qb6a[0][0][0][ic];
    J_c3 += coordinate_dofs[(ic) * 3 + 1] * FE1_C1_D01_Qb6a[0][0][0][ic];
    J_c1 += coordinate_dofs[(ic) * 3] * FE1_C1_D01_Qb6a[0][0][0][ic];
    J_c2 += coordinate_dofs[(ic) * 3 + 1] * FE1_C0_D10_Qb6a[0][0][0][ic];
  }
}
// ------------------------ 
double sp_b6a_0 = J_c0 * J_c3;
double sp_b6a_1 = J_c1 * J_c2;
double sp_b6a_2 = -sp_b6a_1;
double sp_b6a_3 = sp_b6a_0 + sp_b6a_2;
double sp_b6a_4 = fabs(sp_b6a_3);
for (int iq = 0; iq < 15; ++iq)
{
  // ------------------------ 
  // Section: SpatialCoordinate
  // Inputs: coordinate_dofs, FE1_C0_Qb6a
  // Outputs: x_c0
  double x_c0 = 0.0;
  {
    for (int ic = 0; ic < 3; ++ic)
    {
      x_c0 += coordinate_dofs[(ic) * 3] * FE1_C0_Qb6a[0][0][iq][ic];
    }
  }
  // ------------------------ 
  // ------------------------ 
  // Section: SpatialCoordinate
  // Inputs: coordinate_dofs, FE1_C0_Qb6a
  // Outputs: x_c1
  double x_c1 = 0.0;
  {
    for (int ic = 0; ic < 3; ++ic)
    {
      x_c1 += coordinate_dofs[(ic) * 3 + 1] * FE1_C0_Qb6a[0][0][iq][ic];
    }
  }
  // ------------------------ 
  // ------------------------ 
  // Section: Intermediates
  // Inputs: x_c0, x_c1
  // Outputs: fw0
  double fw0 = 0;
  {
    double sv_b6a_0 = 2 * x_c0;
    double sv_b6a_1 = 3.141592653589793 * sv_b6a_0;
    double sv_b6a_2 = sin(sv_b6a_1);
    double sv_b6a_3 = -sv_b6a_2;
    double sv_b6a_4 = 6.283185307179586 * sv_b6a_3;
    double sv_b6a_5 = 6.283185307179586 * sv_b6a_4;
    double sv_b6a_6 = 4 * x_c1;
    double sv_b6a_7 = 3.141592653589793 * sv_b6a_6;
    double sv_b6a_8 = cos(sv_b6a_7);
    double sv_b6a_9 = sv_b6a_5 * sv_b6a_8;
    double sv_b6a_10 = 12.56637061435917 * sv_b6a_8;
    double sv_b6a_11 = -sv_b6a_10;
    double sv_b6a_12 = 12.56637061435917 * sv_b6a_11;
    double sv_b6a_13 = sv_b6a_12 * sv_b6a_2;
    double sv_b6a_14 = sv_b6a_9 + sv_b6a_13;
    double sv_b6a_15 = -sv_b6a_14;
    double sv_b6a_16 = sv_b6a_15 * sp_b6a_4;
    fw0 = sv_b6a_16 * weights_b6a[iq];
  }
  // ------------------------ 
  // ------------------------ 
  // Section: Tensor Computation
  // Inputs: FE1_C0_Qb6a, fw0
  // Outputs: A
  {
    for (int i = 0; i < 3; ++i)
    {
      A[(i)] += fw0 * FE1_C0_Qb6a[0][0][iq][i];
    }
  }
  // ------------------------ 
}

}



ufcx_integral integral_18752a675a270b48bccf204a6576982bd8afabd2 =
{
  .enabled_coefficients = NULL,
  .tabulate_tensor_float32 = NULL,
  .tabulate_tensor_float64 = tabulate_tensor_integral_18752a675a270b48bccf204a6576982bd8afabd2,
  .tabulate_tensor_complex64 = NULL,
  .tabulate_tensor_complex128 = NULL,
  .needs_facet_permutations = false,
  .coordinate_element_hash = UINT64_C(0),
};

// End of code for integral integral_18752a675a270b48bccf204a6576982bd8afabd2

// Code for integral integral_537c29118c78a6169ceeaa35fefdb53435769793

void tabulate_tensor_integral_537c29118c78a6169ceeaa35fefdb53435769793(double* restrict A,
                                    const double* restrict w,
                                    const double* restrict c,
                                    const double* restrict coordinate_dofs,
                                    const int* restrict entity_local_index,
                                    const uint8_t* restrict quadrature_permutation)
{
// Quadrature rules
static const double weights_dc7[4] = {0.1739274225687268, 0.3260725774312731, 0.3260725774312731, 0.1739274225687269};
// Precomputed values of basis functions and precomputations
// FE* dimensions: [permutation][entities][points][dofs]
static const double FE1_C0_D10_F_Qdc7[1][1][1][3] = {{{{-1.0, 1.0, 0.0}}}};
static const double FE1_C1_D01_F_Qdc7[1][1][1][3] = {{{{-1.0, 0.0, 1.0}}}};
static const double FE1_C1_F_Qdc7[1][3][4][3] = {{{{0.0, 0.9305681557970263, 0.06943184420297367},
  {0.0, 0.6699905217924281, 0.3300094782075719},
  {0.0, 0.3300094782075719, 0.669990521792428},
  {0.0, 0.06943184420297373, 0.9305681557970262}},
  {{0.9305681557970263, 0.0, 0.0694318442029737},
  {0.6699905217924282, 0.0, 0.3300094782075719},
  {0.3300094782075719, 0.0, 0.669990521792428},
  {0.06943184420297371, 0.0, 0.9305681557970262}},
  {{0.9305681557970263, 0.06943184420297371, 0.0},
  {0.6699905217924282, 0.3300094782075719, 0.0},
  {0.330009478207572, 0.6699905217924281, 0.0},
  {0.06943184420297391, 0.9305681557970263, 0.0}}}};
static const double triangle_reference_facet_jacobian[3][2][1] = {{{-1.0},
  {1.0}},
  {{0.0},
  {1.0}},
  {{1.0},
  {0.0}}};
static const double triangle_reference_facet_normals[3][2] = {{0.7071067811865475, 0.7071067811865475},
  {-1.0, -0.0},
  {0.0, -1.0}};
// ------------------------ 
// Section: Jacobian
// Inputs: FE1_C1_D01_F_Qdc7, FE1_C0_D10_F_Qdc7, coordinate_dofs
// Outputs: J_c1, J_c3, J_c0, J_c2
double J_c0 = 0.0;
double J_c3 = 0.0;
double J_c1 = 0.0;
double J_c2 = 0.0;
{
  for (int ic = 0; ic < 3; ++ic)
  {
    J_c0 += coordinate_dofs[(ic) * 3] * FE1_C0_D10_F_Qdc7[0][0][0][ic];
    J_c3 += coordinate_dofs[(ic) * 3 + 1] * FE1_C1_D01_F_Qdc7[0][0][0][ic];
    J_c1 += coordinate_dofs[(ic) * 3] * FE1_C1_D01_F_Qdc7[0][0][0][ic];
    J_c2 += coordinate_dofs[(ic) * 3 + 1] * FE1_C0_D10_F_Qdc7[0][0][0][ic];
  }
}
// ------------------------ 
double sp_dc7_0 = J_c0 * J_c3;
double sp_dc7_1 = J_c1 * J_c2;
double sp_dc7_2 = -sp_dc7_1;
double sp_dc7_3 = sp_dc7_0 + sp_dc7_2;
double sp_dc7_4 = J_c0 / sp_dc7_3;
double sp_dc7_5 = triangle_reference_facet_normals[entity_local_index[0]][1] * sp_dc7_4;
double sp_dc7_6 = -J_c1;
double sp_dc7_7 = sp_dc7_6 / sp_dc7_3;
double sp_dc7_8 = triangle_reference_facet_normals[entity_local_index[0]][0] * sp_dc7_7;
double sp_dc7_9 = sp_dc7_5 + sp_dc7_8;
double sp_dc7_10 = sp_dc7_9 * sp_dc7_9;
double sp_dc7_11 = J_c3 / sp_dc7_3;
double sp_dc7_12 = triangle_reference_facet_normals[entity_local_index[0]][0] * sp_dc7_11;
double sp_dc7_13 = -J_c2;
double sp_dc7_14 = sp_dc7_13 / sp_dc7_3;
double sp_dc7_15 = triangle_reference_facet_normals[entity_local_index[0]][1] * sp_dc7_14;
double sp_dc7_16 = sp_dc7_12 + sp_dc7_15;
double sp_dc7_17 = sp_dc7_16 * sp_dc7_16;
double sp_dc7_18 = sp_dc7_10 + sp_dc7_17;
double sp_dc7_19 = sqrt(sp_dc7_18);
double sp_dc7_20 = sp_dc7_9 / sp_dc7_19;
double sp_dc7_21 = sp_dc7_16 / sp_dc7_19;
double sp_dc7_22 = J_c0 * triangle_reference_facet_jacobian[entity_local_index[0]][0][0];
double sp_dc7_23 = J_c1 * triangle_reference_facet_jacobian[entity_local_index[0]][1][0];
double sp_dc7_24 = sp_dc7_22 + sp_dc7_23;
double sp_dc7_25 = sp_dc7_24 * sp_dc7_24;
double sp_dc7_26 = triangle_reference_facet_jacobian[entity_local_index[0]][0][0] * J_c2;
double sp_dc7_27 = triangle_reference_facet_jacobian[entity_local_index[0]][1][0] * J_c3;
double sp_dc7_28 = sp_dc7_26 + sp_dc7_27;
double sp_dc7_29 = sp_dc7_28 * sp_dc7_28;
double sp_dc7_30 = sp_dc7_25 + sp_dc7_29;
double sp_dc7_31 = sqrt(sp_dc7_30);
for (int iq = 0; iq < 4; ++iq)
{
  // ------------------------ 
  // Section: SpatialCoordinate
  // Inputs: coordinate_dofs, FE1_C1_F_Qdc7
  // Outputs: x_c1
  double x_c1 = 0.0;
  {
    for (int ic = 0; ic < 3; ++ic)
    {
      x_c1 += coordinate_dofs[(ic) * 3 + 1] * FE1_C1_F_Qdc7[0][entity_local_index[0]][iq][ic];
    }
  }
  // ------------------------ 
  // ------------------------ 
  // Section: SpatialCoordinate
  // Inputs: coordinate_dofs, FE1_C1_F_Qdc7
  // Outputs: x_c0
  double x_c0 = 0.0;
  {
    for (int ic = 0; ic < 3; ++ic)
    {
      x_c0 += coordinate_dofs[(ic) * 3] * FE1_C1_F_Qdc7[0][entity_local_index[0]][iq][ic];
    }
  }
  // ------------------------ 
  // ------------------------ 
  // Section: Intermediates
  // Inputs: x_c1, x_c0
  // Outputs: fw0
  double fw0 = 0;
  {
    double sv_dc7_0 = 4 * x_c1;
    double sv_dc7_1 = 3.141592653589793 * sv_dc7_0;
    double sv_dc7_2 = sin(sv_dc7_1);
    double sv_dc7_3 = -sv_dc7_2;
    double sv_dc7_4 = 12.56637061435917 * sv_dc7_3;
    double sv_dc7_5 = 2 * x_c0;
    double sv_dc7_6 = 3.141592653589793 * sv_dc7_5;
    double sv_dc7_7 = sin(sv_dc7_6);
    double sv_dc7_8 = sv_dc7_4 * sv_dc7_7;
    double sv_dc7_9 = sv_dc7_8 * sp_dc7_20;
    double sv_dc7_10 = cos(sv_dc7_6);
    double sv_dc7_11 = 6.283185307179586 * sv_dc7_10;
    double sv_dc7_12 = cos(sv_dc7_1);
    double sv_dc7_13 = sv_dc7_11 * sv_dc7_12;
    double sv_dc7_14 = sv_dc7_13 * sp_dc7_21;
    double sv_dc7_15 = sv_dc7_9 + sv_dc7_14;
    double sv_dc7_16 = sv_dc7_15 * sp_dc7_31;
    fw0 = sv_dc7_16 * weights_dc7[iq];
  }
  // ------------------------ 
  // ------------------------ 
  // Section: Tensor Computation
  // Inputs: fw0, FE1_C1_F_Qdc7
  // Outputs: A
  {
    for (int i = 0; i < 3; ++i)
    {
      A[(i)] += fw0 * FE1_C1_F_Qdc7[0][entity_local_index[0]][iq][i];
    }
  }
  // ------------------------ 
}

}



ufcx_integral integral_537c29118c78a6169ceeaa35fefdb53435769793 =
{
  .enabled_coefficients = NULL,
  .tabulate_tensor_float32 = NULL,
  .tabulate_tensor_float64 = tabulate_tensor_integral_537c29118c78a6169ceeaa35fefdb53435769793,
  .tabulate_tensor_complex64 = NULL,
  .tabulate_tensor_complex128 = NULL,
  .needs_facet_permutations = false,
  .coordinate_element_hash = UINT64_C(0),
};

// End of code for integral integral_537c29118c78a6169ceeaa35fefdb53435769793

// Code for integral integral_b54524d6f4d745485213adb099cdab6575e3796a

void tabulate_tensor_integral_b54524d6f4d745485213adb099cdab6575e3796a(double* restrict A,
                                    const double* restrict w,
                                    const double* restrict c,
                                    const double* restrict coordinate_dofs,
                                    const int* restrict entity_local_index,
                                    const uint8_t* restrict quadrature_permutation)
{
// Quadrature rules
static const double weights_a26[33] = {0.03127060659795138, 0.01424302603443878, 0.02495916746403047, 0.01213341904072602, 0.003965821254986819, 0.03127060659795138, 0.01424302603443878, 0.02495916746403047, 0.01213341904072602, 0.003965821254986819, 0.03127060659795138, 0.01424302603443878, 0.02495916746403047, 0.01213341904072602, 0.003965821254986819, 0.0216136818297071, 0.007541838788255721, 0.01089179251930378, 0.0216136818297071, 0.007541838788255721, 0.01089179251930378, 0.0216136818297071, 0.007541838788255721, 0.01089179251930378, 0.0216136818297071, 0.007541838788255721, 0.01089179251930378, 0.0216136818297071, 0.007541838788255721, 0.01089179251930378, 0.0216136818297071, 0.007541838788255721, 0.01089179251930378};
// Precomputed values of basis functions and precomputations
// FE* dimensions: [permutation][entities][points][dofs]
static const double FE1_C0_D10_Qa26[1][1][1][3] = {{{{-1.0, 1.0, 0.0}}}};
static const double FE1_C1_D01_Qa26[1][1][1][3] = {{{{-1.0, 0.0, 1.0}}}};
static const double FE1_C1_Qa26[1][1][33][3] = {{{{0.4570749859701478, 0.2714625070149261, 0.2714625070149261},
  {0.7814843446812914, 0.1092578276593543, 0.1092578276593543},
  {0.1197767026828138, 0.4401116486585931, 0.4401116486585931},
  {0.02359249810891699, 0.4882037509455415, 0.4882037509455415},
  {0.9507072731273287, 0.0246463634363356, 0.02464636343633566},
  {0.2714625070149261, 0.2714625070149261, 0.4570749859701477},
  {0.1092578276593543, 0.1092578276593543, 0.7814843446812914},
  {0.4401116486585931, 0.4401116486585931, 0.1197767026828138},
  {0.4882037509455416, 0.4882037509455415, 0.02359249810891695},
  {0.02464636343633559, 0.02464636343633559, 0.9507072731273287},
  {0.2714625070149262, 0.4570749859701477, 0.2714625070149261},
  {0.1092578276593544, 0.7814843446812914, 0.1092578276593543},
  {0.4401116486585931, 0.1197767026828138, 0.4401116486585931},
  {0.4882037509455416, 0.02359249810891686, 0.4882037509455415},
  {0.02464636343633575, 0.9507072731273287, 0.02464636343633562},
  {0.6282497516835561, 0.1162960196779265, 0.2554542286385174},
  {0.85133779251024, 0.02138249025617065, 0.1272797172335894},
  {0.6853101639063919, 0.02303415635526718, 0.2916556797383409},
  {0.2554542286385174, 0.6282497516835561, 0.1162960196779266},
  {0.1272797172335896, 0.85133779251024, 0.02138249025617062},
  {0.291655679738341, 0.6853101639063919, 0.02303415635526717},
  {0.1162960196779265, 0.2554542286385174, 0.6282497516835561},
  {0.02138249025617066, 0.1272797172335893, 0.8513377925102399},
  {0.02303415635526719, 0.2916556797383409, 0.6853101639063919},
  {0.6282497516835561, 0.2554542286385174, 0.1162960196779266},
  {0.8513377925102401, 0.1272797172335892, 0.02138249025617065},
  {0.6853101639063919, 0.2916556797383409, 0.02303415635526718},
  {0.1162960196779266, 0.6282497516835561, 0.2554542286385174},
  {0.02138249025617079, 0.85133779251024, 0.1272797172335893},
  {0.02303415635526729, 0.6853101639063919, 0.2916556797383409},
  {0.2554542286385173, 0.1162960196779265, 0.6282497516835561},
  {0.1272797172335894, 0.02138249025617059, 0.8513377925102399},
  {0.2916556797383409, 0.02303415635526714, 0.6853101639063919}}}};
// ------------------------ 
// Section: Jacobian
// Inputs: FE1_C0_D10_Qa26, FE1_C1_D01_Qa26, coordinate_dofs
// Outputs: J_c1, J_c3, J_c0, J_c2
double J_c0 = 0.0;
double J_c3 = 0.0;
double J_c1 = 0.0;
double J_c2 = 0.0;
{
  for (int ic = 0; ic < 3; ++ic)
  {
    J_c0 += coordinate_dofs[(ic) * 3] * FE1_C0_D10_Qa26[0][0][0][ic];
    J_c3 += coordinate_dofs[(ic) * 3 + 1] * FE1_C1_D01_Qa26[0][0][0][ic];
    J_c1 += coordinate_dofs[(ic) * 3] * FE1_C1_D01_Qa26[0][0][0][ic];
    J_c2 += coordinate_dofs[(ic) * 3 + 1] * FE1_C0_D10_Qa26[0][0][0][ic];
  }
}
// ------------------------ 
double sp_a26_0 = J_c0 * J_c3;
double sp_a26_1 = J_c1 * J_c2;
double sp_a26_2 = -sp_a26_1;
double sp_a26_3 = sp_a26_0 + sp_a26_2;
double sp_a26_4 = fabs(sp_a26_3);
for (int iq = 0; iq < 33; ++iq)
{
  // ------------------------ 
  // Section: SpatialCoordinate
  // Inputs: coordinate_dofs, FE1_C1_Qa26
  // Outputs: x_c1
  double x_c1 = 0.0;
  {
    for (int ic = 0; ic < 3; ++ic)
    {
      x_c1 += coordinate_dofs[(ic) * 3 + 1] * FE1_C1_Qa26[0][0][iq][ic];
    }
  }
  // ------------------------ 
  // ------------------------ 
  // Section: SpatialCoordinate
  // Inputs: coordinate_dofs, FE1_C1_Qa26
  // Outputs: x_c0
  double x_c0 = 0.0;
  {
    for (int ic = 0; ic < 3; ++ic)
    {
      x_c0 += coordinate_dofs[(ic) * 3] * FE1_C1_Qa26[0][0][iq][ic];
    }
  }
  // ------------------------ 
  // ------------------------ 
  // Section: Coefficient
  // Inputs: FE1_C1_Qa26, w
  // Outputs: w0
  double w0 = 0.0;
  {
    for (int ic = 0; ic < 3; ++ic)
    {
      w0 += w[ic] * FE1_C1_Qa26[0][0][iq][ic];
    }
  }
  // ------------------------ 
  // ------------------------ 
  // Section: Intermediates
  // Inputs: x_c1, x_c0, w0
  // Outputs: fw0
  double fw0 = 0;
  {
    double sv_a26_0 = 4 * x_c1;
    double sv_a26_1 = 3.141592653589793 * sv_a26_0;
    double sv_a26_2 = cos(sv_a26_1);
    double sv_a26_3 = 2 * x_c0;
    double sv_a26_4 = 3.141592653589793 * sv_a26_3;
    double sv_a26_5 = sin(sv_a26_4);
    double sv_a26_6 = sv_a26_2 * sv_a26_5;
    double sv_a26_7 = -w0;
    double sv_a26_8 = sv_a26_6 + sv_a26_7;
    double sv_a26_9 = sv_a26_8 * sv_a26_8;
    double sv_a26_10 = sv_a26_9 * sp_a26_4;
    fw0 = sv_a26_10 * weights_a26[iq];
  }
  // ------------------------ 
  // ------------------------ 
  // Section: Tensor Computation
  // Inputs: fw0
  // Outputs: A
  {
    A[0] += fw0;
  }
  // ------------------------ 
}

}

bool enabled_coefficients_integral_b54524d6f4d745485213adb099cdab6575e3796a[1] = {1};

ufcx_integral integral_b54524d6f4d745485213adb099cdab6575e3796a =
{
  .enabled_coefficients = enabled_coefficients_integral_b54524d6f4d745485213adb099cdab6575e3796a,
  .tabulate_tensor_float32 = NULL,
  .tabulate_tensor_float64 = tabulate_tensor_integral_b54524d6f4d745485213adb099cdab6575e3796a,
  .tabulate_tensor_complex64 = NULL,
  .tabulate_tensor_complex128 = NULL,
  .needs_facet_permutations = false,
  .coordinate_element_hash = UINT64_C(0),
};

// End of code for integral integral_b54524d6f4d745485213adb099cdab6575e3796a

// Code for form form_2972e6bc9d09f8385331926cec783d9a3f5c068a


uint64_t finite_element_hashes_form_2972e6bc9d09f8385331926cec783d9a3f5c068a[2] = {UINT64_C(16933917890882727400), UINT64_C(16933917890882727400)};
int form_integral_offsets_form_2972e6bc9d09f8385331926cec783d9a3f5c068a[4] = {0, 1, 1, 1};
static ufcx_integral* form_integrals_form_2972e6bc9d09f8385331926cec783d9a3f5c068a[1] = {&integral_9e589da66bac6e7e5c5bc39b3de7d7e115f993ce};
int form_integral_ids_form_2972e6bc9d09f8385331926cec783d9a3f5c068a[1] = {-1};




ufcx_form form_2972e6bc9d09f8385331926cec783d9a3f5c068a =
{

  .signature = "74d62cd9e9cb4ac1c2add00c783097b7c03e355f9f9b817fc63ac3d97239e83a635e9310f0bd90b893121c0be6e44a8edb55ddacae1b99c8dfed7904a8694118",
  .rank = 2,
  .num_coefficients = 0,
  .num_constants = 0,
  .original_coefficient_positions = NULL,

  .coefficient_name_map = NULL,
  .constant_name_map = NULL,

  .finite_element_hashes = finite_element_hashes_form_2972e6bc9d09f8385331926cec783d9a3f5c068a,

  .form_integrals = form_integrals_form_2972e6bc9d09f8385331926cec783d9a3f5c068a,
  .form_integral_ids = form_integral_ids_form_2972e6bc9d09f8385331926cec783d9a3f5c068a,
  .form_integral_offsets = form_integral_offsets_form_2972e6bc9d09f8385331926cec783d9a3f5c068a
};

// Alias name
ufcx_form* form_poisson_a00 = &form_2972e6bc9d09f8385331926cec783d9a3f5c068a;

// End of code for form form_2972e6bc9d09f8385331926cec783d9a3f5c068a

// Code for form form_3de593bba45fbcc67f9275d68855b5be0bc5f5e4


uint64_t finite_element_hashes_form_3de593bba45fbcc67f9275d68855b5be0bc5f5e4[2] = {UINT64_C(16933917890882727400), UINT64_C(16933917890882691059)};
int form_integral_offsets_form_3de593bba45fbcc67f9275d68855b5be0bc5f5e4[4] = {0, 1, 1, 1};
static ufcx_integral* form_integrals_form_3de593bba45fbcc67f9275d68855b5be0bc5f5e4[1] = {&integral_b48d1eb48e2e0769ab58b939256a7911f4da7c3d};
int form_integral_ids_form_3de593bba45fbcc67f9275d68855b5be0bc5f5e4[1] = {-1};




ufcx_form form_3de593bba45fbcc67f9275d68855b5be0bc5f5e4 =
{

  .signature = "307140a6d64b035efe2522ecea2a701c5fe4207b35eb23c81ab87d176d7921cdf00b1c3ec1c5afdfa12bb567df21a8663c2b336a0b31118e526f3cdfbea355dd",
  .rank = 2,
  .num_coefficients = 0,
  .num_constants = 0,
  .original_coefficient_positions = NULL,

  .coefficient_name_map = NULL,
  .constant_name_map = NULL,

  .finite_element_hashes = finite_element_hashes_form_3de593bba45fbcc67f9275d68855b5be0bc5f5e4,

  .form_integrals = form_integrals_form_3de593bba45fbcc67f9275d68855b5be0bc5f5e4,
  .form_integral_ids = form_integral_ids_form_3de593bba45fbcc67f9275d68855b5be0bc5f5e4,
  .form_integral_offsets = form_integral_offsets_form_3de593bba45fbcc67f9275d68855b5be0bc5f5e4
};

// Alias name
ufcx_form* form_poisson_a01 = &form_3de593bba45fbcc67f9275d68855b5be0bc5f5e4;

// End of code for form form_3de593bba45fbcc67f9275d68855b5be0bc5f5e4

// Code for form form_7599960fc3237e76c60798aff84ef6ea0ad8d73a


uint64_t finite_element_hashes_form_7599960fc3237e76c60798aff84ef6ea0ad8d73a[2] = {UINT64_C(16933917890882691059), UINT64_C(16933917890882727400)};
int form_integral_offsets_form_7599960fc3237e76c60798aff84ef6ea0ad8d73a[4] = {0, 1, 1, 1};
static ufcx_integral* form_integrals_form_7599960fc3237e76c60798aff84ef6ea0ad8d73a[1] = {&integral_b1a56654466bd2be9d6044d1e031c51bc4198978};
int form_integral_ids_form_7599960fc3237e76c60798aff84ef6ea0ad8d73a[1] = {-1};




ufcx_form form_7599960fc3237e76c60798aff84ef6ea0ad8d73a =
{

  .signature = "3aec504b955d87bea2117aa3e4bbc2c77b24ee79792ed5d89159e59c6a4443115a0b1f801ebdd13c5aac29feee293b3ac1a014d3689b93f9481b7869005a0b7f",
  .rank = 2,
  .num_coefficients = 0,
  .num_constants = 0,
  .original_coefficient_positions = NULL,

  .coefficient_name_map = NULL,
  .constant_name_map = NULL,

  .finite_element_hashes = finite_element_hashes_form_7599960fc3237e76c60798aff84ef6ea0ad8d73a,

  .form_integrals = form_integrals_form_7599960fc3237e76c60798aff84ef6ea0ad8d73a,
  .form_integral_ids = form_integral_ids_form_7599960fc3237e76c60798aff84ef6ea0ad8d73a,
  .form_integral_offsets = form_integral_offsets_form_7599960fc3237e76c60798aff84ef6ea0ad8d73a
};

// Alias name
ufcx_form* form_poisson_a10 = &form_7599960fc3237e76c60798aff84ef6ea0ad8d73a;

// End of code for form form_7599960fc3237e76c60798aff84ef6ea0ad8d73a

// Code for form form_08f7f0cc80d298df83c68b776e1f11413c13543a


uint64_t finite_element_hashes_form_08f7f0cc80d298df83c68b776e1f11413c13543a[1] = {UINT64_C(16933917890882727400)};
int form_integral_offsets_form_08f7f0cc80d298df83c68b776e1f11413c13543a[4] = {0, 1, 2, 2};
static ufcx_integral* form_integrals_form_08f7f0cc80d298df83c68b776e1f11413c13543a[2] = {&integral_18752a675a270b48bccf204a6576982bd8afabd2, &integral_537c29118c78a6169ceeaa35fefdb53435769793};
int form_integral_ids_form_08f7f0cc80d298df83c68b776e1f11413c13543a[2] = {-1, -1};




ufcx_form form_08f7f0cc80d298df83c68b776e1f11413c13543a =
{

  .signature = "a0dbb39f65a0100177f917db094fc6238a8df5668f83441399796f1503b8ea6f91b7a76204b3bc890eff433ff4952de919cdbc80c77646cdde78f3380e1578fe",
  .rank = 1,
  .num_coefficients = 0,
  .num_constants = 0,
  .original_coefficient_positions = NULL,

  .coefficient_name_map = NULL,
  .constant_name_map = NULL,

  .finite_element_hashes = finite_element_hashes_form_08f7f0cc80d298df83c68b776e1f11413c13543a,

  .form_integrals = form_integrals_form_08f7f0cc80d298df83c68b776e1f11413c13543a,
  .form_integral_ids = form_integral_ids_form_08f7f0cc80d298df83c68b776e1f11413c13543a,
  .form_integral_offsets = form_integral_offsets_form_08f7f0cc80d298df83c68b776e1f11413c13543a
};

// Alias name
ufcx_form* form_poisson_L = &form_08f7f0cc80d298df83c68b776e1f11413c13543a;

// End of code for form form_08f7f0cc80d298df83c68b776e1f11413c13543a

// Code for form form_7c51841ef24c900ea72b576a0bbab162e2acfcc3

int original_coefficient_position_form_7c51841ef24c900ea72b576a0bbab162e2acfcc3[1] = {0};
uint64_t finite_element_hashes_form_7c51841ef24c900ea72b576a0bbab162e2acfcc3[1] = {UINT64_C(16933917890882727400)};
int form_integral_offsets_form_7c51841ef24c900ea72b576a0bbab162e2acfcc3[4] = {0, 1, 1, 1};
static ufcx_integral* form_integrals_form_7c51841ef24c900ea72b576a0bbab162e2acfcc3[1] = {&integral_b54524d6f4d745485213adb099cdab6575e3796a};
int form_integral_ids_form_7c51841ef24c900ea72b576a0bbab162e2acfcc3[1] = {-1};

static const char* coefficient_names_form_7c51841ef24c900ea72b576a0bbab162e2acfcc3[1] = {"uh"};


ufcx_form form_7c51841ef24c900ea72b576a0bbab162e2acfcc3 =
{

  .signature = "9b86d66a99c9c031beada5c636b8c97687b60474bb16451c6a5d15f2ff43eeffabb42ce182487229f69aa57e779edd8cf81562801bc0d2db4640ffac6fe56c17",
  .rank = 0,
  .num_coefficients = 1,
  .num_constants = 0,
  .original_coefficient_positions = original_coefficient_position_form_7c51841ef24c900ea72b576a0bbab162e2acfcc3,

  .coefficient_name_map = coefficient_names_form_7c51841ef24c900ea72b576a0bbab162e2acfcc3,
  .constant_name_map = NULL,

  .finite_element_hashes = finite_element_hashes_form_7c51841ef24c900ea72b576a0bbab162e2acfcc3,

  .form_integrals = form_integrals_form_7c51841ef24c900ea72b576a0bbab162e2acfcc3,
  .form_integral_ids = form_integral_ids_form_7c51841ef24c900ea72b576a0bbab162e2acfcc3,
  .form_integral_offsets = form_integral_offsets_form_7c51841ef24c900ea72b576a0bbab162e2acfcc3
};

// Alias name
ufcx_form* form_poisson_J = &form_7c51841ef24c900ea72b576a0bbab162e2acfcc3;

// End of code for form form_7c51841ef24c900ea72b576a0bbab162e2acfcc3
